variables:
  # This will supress any download for dependencies and plugins or upload messages which would clutter the console log.
  # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true"
  # As of Maven 3.3.0 instead of this you may define these options in `.mvn/maven.config` so the same config is used
  # when running from the command line.
  # `installAtEnd` and `deployAtEnd` are only effective with recent version of the corresponding plugins.
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""


default:
  image: openjdk:11-slim
  # Cache downloaded dependencies and plugins between builds.
  # To keep cache across branches add 'key: "$CI_JOB_NAME"'
  # Define a cache with the key: ${CI_COMMIT_REF_SLUG} so that jobs of each branch always use the same cache
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .m2/repository

stages:
  - compile
  - test
  - build
  - deploy

mvn-compile:
  stage: compile
  script:
    - "./mvnw $MAVEN_CLI_OPTS clean compile"

unit-int-test:
  stage: test
  coverage: '/Total.*?([0-9]{1,3})%/'
  script:
    - "./mvnw $MAVEN_CLI_OPTS clean verify"
    - "cat target/site/jacoco/index.html"

docker-image:
  stage: build
  image: registry.gitlab.com/berufsschul-ae/spiele-vergleicher/docker-openjdk11
  cache: {}
  services:
    - docker:19.03.0-dind
  before_script:
    - "docker login registry.gitlab.com -u $DOCKER_USERNAME -p $DOCKER_PASSWORD"
  script:
    - "docker build --pull --tag registry.gitlab.com/berufsschul-ae/spiele-vergleicher-gamedb/game-db-service:latest ."
    - "docker push registry.gitlab.com/berufsschul-ae/spiele-vergleicher-gamedb/game-db-service:latest"
  only:
    - develop

docker-image-tags:
  stage: build
  image: registry.gitlab.com/berufsschul-ae/spiele-vergleicher/docker-openjdk11
  cache: {}
  services:
    - docker:19.03.0-dind
  before_script:
    - "docker login registry.gitlab.com -u $DOCKER_USERNAME -p $DOCKER_PASSWORD"
  script:
    - "docker build --pull --tag registry.gitlab.com/berufsschul-ae/spiele-vergleicher-gamedb/game-db-service:latest --tag registry.gitlab.com/berufsschul-ae/spiele-vergleicher-gamedb/game-db-service:$CI_COMMIT_TAG ."
    - "docker push registry.gitlab.com/berufsschul-ae/spiele-vergleicher-gamedb/game-db-service:latest"
    - "docker push registry.gitlab.com/berufsschul-ae/spiele-vergleicher-gamedb/game-db-service:$CI_COMMIT_TAG"
  only:
    - tags

deploy-latest-docker-version:
  stage: deploy
  tags:
    - deployment
  cache: {}
  script:
    - "docker pull registry.gitlab.com/berufsschul-ae/spiele-vergleicher-gamedb/game-db-service:latest"
    - "docker-compose up -d --no-deps gamedb"
  only:
    - develop